#ifndef INSTANCE_H_INCLUDED_
#define INSTANCE_H_INCLUDED_

#include <string>

#include "rose.h"
#include "object.h"

namespace risc {

class Module;

/**
 * \class Module
 * \brief This class represents instances
 */
class Instance: public Object{

public:

  /**
   * \brief Default constructor
   */
  explicit Instance(SgVariableDefinition *ast_node, Type type);

  /**
   * \brief Get function for the name of the ast type of the module instance
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

  virtual Class* get_definition() = 0;

private:
  /**
   * \brief Disabled copy constructor
   */
  Instance(const Instance &i);
};


typedef std::vector<Instance*> InstanceVector;
typedef std::vector<Instance*>::iterator InstanceVectorIter;
typedef std::vector<Instance*>::const_iterator InstanceVectorConstIter;

}; // end namespace risc

#endif /* INSTANCE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
