// one_notify_one_wait.cc
// 04/11/17 RD   added assertions
// 04/04/17 ZC   initial version

#include <stdio.h>
#include "systemc.h"

#define ITERATIONS 500

class Main_Block : public sc_module
{
    public:
	sc_event e;
	int s, r;

	void S()
	{
		printf("S starting\n");
		s = 1;
		wait(1,SC_NS);
		for(int i=0;i<ITERATIONS;i++){
			e.notify(SC_ZERO_TIME);
			wait(2,SC_NS);
			s++;
		}
		assert(s == ITERATIONS+1);
		printf("S done\n");
	}

	void R()
	{
		printf("R starting\n");
		r = 1;
		for(int i=0;i<ITERATIONS;i++){
			wait(e);
			r++;
		}
		printf("R done\n");
		assert(r == ITERATIONS+1);
	}

	Main_Block(sc_module_name name)
	: sc_module(name)
	{
		s = r = 0;
		SC_THREAD(S);
		SC_THREAD(R);
	}
	SC_HAS_PROCESS(Main_Block);
};

class Platform : public sc_module
{
    public:
	Main_Block m;

	Platform(sc_module_name name)
	: sc_module(name),
	m("m")
	{
		printf("one_notify_one_wait constructor\n");
	}
	SC_HAS_PROCESS(Platform);
};

int sc_main(int argc, char* argv[])
{
    Platform p("p");

    printf("one_notify_one_wait starting\n");
    assert(p.m.s == 0);
    assert(p.m.r == 0);
    sc_start();
    assert(p.m.s == ITERATIONS+1);
    assert(p.m.r == ITERATIONS+1);
    printf("one_notify_one_wait done\n");
    return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
