#include "systemc.h"

class ModuleA: public sc_module {

  SC_HAS_PROCESS(ModuleA);

public:

  ModuleA(sc_module_name mn):
    sc_module(mn)
  {
#if 1
    SC_THREAD(thread1);
    SC_THREAD(thread2);

    SC_THREAD(thread3);
    SC_THREAD(thread4);

    SC_THREAD(thread5);
    SC_THREAD(thread6);

    SC_THREAD(thread7);
    SC_THREAD(thread8);

    SC_THREAD(thread9);
    SC_THREAD(thread10);
    SC_THREAD(thread11);

    SC_THREAD(thread12);
    SC_THREAD(thread13);
    SC_THREAD(thread14);
#endif
  }

  sc_event event1;
  sc_event event2;
  void thread1()
  {
    if(true) {

      wait(10, SC_FS);
    } else {

      wait(5, SC_FS);
    }

    wait(3, SC_FS);

    wait(2, SC_FS);

    event1.notify(SC_ZERO_TIME);

    wait(1, SC_FS);

    event2.notify(SC_ZERO_TIME);
  }
  void thread2()
  {

    wait(SC_ZERO_TIME);

    wait(event1);

    wait(event2);
  }

  sc_event event3;
  sc_event event4;
  void thread3()
  {
    if(true) {

      wait(5, SC_FS);
    } else {

      wait(10, SC_FS);
    }

    wait(3, SC_FS);

    wait(2, SC_FS);

    event3.notify(SC_ZERO_TIME);

    wait(1, SC_FS);

    event4.notify(SC_ZERO_TIME);
  }
  void thread4()
  {

    wait(SC_ZERO_TIME);

    wait(event3);

    wait(event4);
  }

  sc_event event5;
  sc_event event6;
  void thread5()
  {
    event5.notify(SC_ZERO_TIME);
    wait(10, SC_FS);

    wait(event6);
  }
  void thread6()
  {
    wait(event5);
    wait(2, SC_FS);
    event6.notify(SC_ZERO_TIME);
  }

  sc_event event7;
  void thread7()
  {
    wait(10, SC_FS);
    event7.notify(SC_ZERO_TIME);
    wait(3, SC_FS);
    wait(4, SC_FS);
  }
  void thread8()
  {
    wait(1, SC_FS);
    wait(event7);
    wait(20, SC_FS);
  }

  sc_event event8;
  sc_event event9;
  void thread9()
  {
    event8.notify(SC_ZERO_TIME);
    wait(1, SC_FS);
    wait(2, SC_FS);
    wait(3, SC_FS);
  }
  void thread10()
  {
    wait(event8);
    wait(3, SC_FS);
    event9.notify(SC_ZERO_TIME);
    wait(7, SC_FS);
  }
  void thread11()
  {
    wait(1, SC_FS);
    wait(2, SC_FS);
    wait(event9);
  }

  sc_event event10;
  sc_event event11;
  void thread12()
  {
    event10.notify(SC_ZERO_TIME);
    wait(1, SC_FS);
    wait(2, SC_FS);
    wait(3, SC_FS);
  }
  void thread13()
  {
    wait(event10);
    event11.notify(SC_ZERO_TIME);
    wait(4, SC_FS);
    wait(5, SC_FS);
  }
  void thread14()
  {
    wait(6, SC_FS);
    wait(event11);
    wait(7, SC_FS);
  }
};


class ModuleK: public sc_module {

  SC_HAS_PROCESS(ModuleK);
  sc_event &to_notify_;
  int k;

public:

  ModuleK(sc_module_name mn, sc_event &to_notify):
    sc_module(mn),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    k;
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleL: public sc_module {

  SC_HAS_PROCESS(ModuleL);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int l;

public:

  ModuleL(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    l;
    wait(for_wait_);
    wait(10, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleN: public sc_module {

  SC_HAS_PROCESS(ModuleN);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int n;

public:

  ModuleN(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    n;
    wait(for_wait_);
    wait(20, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleM: public sc_module {

  SC_HAS_PROCESS(ModuleM);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int m;

public:

  ModuleM(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    m;
    wait(for_wait_);
    wait(30, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};


class ModuleO: public sc_module {

  SC_HAS_PROCESS(ModuleO);
  sc_event &wait_event_;
  int o;

public:

  ModuleO(sc_module_name mn, sc_event &wait_event):
    sc_module(mn),
    wait_event_(wait_event)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    o;
    wait(wait_event_);
  }
};


class Module: public sc_module {

public:

  ModuleK k1;
  ModuleK k2;
  ModuleL l;
  ModuleN n;

  ModuleM m;
  ModuleO o;

  sc_event k1_to_l;
  sc_event k2_to_n;

  sc_event nl_to_m;
  sc_event m_to_o;

  Module(sc_module_name mn):
    sc_module(mn),
    k1("k1", k1_to_l),
    k2("k2", k2_to_n),
    l("l", k1_to_l, nl_to_m),
    n("n", k2_to_n, nl_to_m),
    m("m", nl_to_m, m_to_o),
    o("o", m_to_o)
  { }
};

class ModuleK1: public sc_module {

  SC_HAS_PROCESS(ModuleK1);
  sc_event &to_notify_;
  int k;

public:

  ModuleK1(sc_module_name mn, sc_event &to_notify):
    sc_module(mn),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    k;
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleL1: public sc_module {

  SC_HAS_PROCESS(ModuleL1);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int l;

public:

  ModuleL1(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    l;
    wait(for_wait_);
    wait(10, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleN1: public sc_module {

  SC_HAS_PROCESS(ModuleN1);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int n;

public:

  ModuleN1(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    n;
    wait(for_wait_);
    wait(20, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleM1: public sc_module {

  SC_HAS_PROCESS(ModuleM1);
  sc_event &for_wait_1_;
  sc_event &for_wait_2_;
  sc_event &to_notify_;
  sc_event_and_list event_list;
  int m;

public:

  ModuleM1(sc_module_name mn, sc_event &for_wait_1, sc_event &for_wait_2, sc_event &to_notify):
    sc_module(mn),
    for_wait_1_(for_wait_1),
    for_wait_2_(for_wait_2),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    m;
    wait(event_list);
    wait(30, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }

  void before_end_of_elaboration()
  {
    event_list &= for_wait_1_;
    event_list &= for_wait_2_;
  }
};


class ModuleO1: public sc_module {

  SC_HAS_PROCESS(ModuleO1);
  sc_event &wait_event_;
  int o;

public:

  ModuleO1(sc_module_name mn, sc_event &wait_event):
    sc_module(mn),
    wait_event_(wait_event)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    o;
    wait(wait_event_);
  }
};


class ModuleAndList: public sc_module {

public:

  ModuleK1 k1;
  ModuleK1 k2;
  ModuleL1 l;
  ModuleN1 n;

  ModuleM1 m;
  ModuleO1 o;

  sc_event k1_to_l;
  sc_event k2_to_n;

  sc_event l_to_m;
  sc_event n_to_m;
  sc_event m_to_o;

  ModuleAndList(sc_module_name mn):
    sc_module(mn),
    k1("k1", k1_to_l),
    k2("k2", k2_to_n),
    l("l", k1_to_l, l_to_m),
    n("n", k2_to_n, n_to_m),
    m("m", l_to_m, n_to_m, m_to_o),
    o("o", m_to_o)
  { }
};


class ModuleK2: public sc_module {

  SC_HAS_PROCESS(ModuleK2);
  sc_event &to_notify_;
  int k;

public:

  ModuleK2(sc_module_name mn, sc_event &to_notify):
    sc_module(mn),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    k;
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleL2: public sc_module {

  SC_HAS_PROCESS(ModuleL2);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int l;

public:

  ModuleL2(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    l;
    wait(for_wait_);
    wait(10, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleN2: public sc_module {

  SC_HAS_PROCESS(ModuleN2);
  sc_event &for_wait_;
  sc_event &to_notify_;
  int n;

public:

  ModuleN2(sc_module_name mn, sc_event &for_wait, sc_event &to_notify):
    sc_module(mn),
    for_wait_(for_wait),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    n;
    wait(for_wait_);
    wait(20, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }
};

class ModuleM2: public sc_module {

  SC_HAS_PROCESS(ModuleM2);
  sc_event &for_wait_1_;
  sc_event &for_wait_2_;
  sc_event &to_notify_;
  sc_event_or_list event_list;
  int m;

public:

  ModuleM2(sc_module_name mn, sc_event &for_wait_1, sc_event &for_wait_2, sc_event &to_notify):
    sc_module(mn),
    for_wait_1_(for_wait_1),
    for_wait_2_(for_wait_2),
    to_notify_(to_notify)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    m;
    wait(event_list);
    wait(30, SC_FS);
    to_notify_.notify(SC_ZERO_TIME);
  }

  void before_end_of_elaboration()
  {
    event_list |= for_wait_1_;
    event_list |= for_wait_2_;
  }
};


class ModuleO2: public sc_module {

  SC_HAS_PROCESS(ModuleO2);
  sc_event &wait_event_;
  int o;

public:

  ModuleO2(sc_module_name mn, sc_event &wait_event):
    sc_module(mn),
    wait_event_(wait_event)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    o;
    wait(wait_event_);
  }
};


class ModuleOrList: public sc_module {

public:

  ModuleK2 k1;
  ModuleK2 k2;
  ModuleL2 l;
  ModuleN2 n;

  ModuleM2 m;
  ModuleO2 o;

  sc_event k1_to_l;
  sc_event k2_to_n;

  sc_event l_to_m;
  sc_event n_to_m;
  sc_event m_to_o;

  ModuleOrList(sc_module_name mn):
    sc_module(mn),
    k1("k1", k1_to_l),
    k2("k2", k2_to_n),
    l("l", k1_to_l, l_to_m),
    n("n", k2_to_n, n_to_m),
    m("m", l_to_m, n_to_m, m_to_o),
    o("o", m_to_o)
  { }
};

class TopModule: public sc_module {

  ModuleA a;
  Module m;
  ModuleOrList m_or;
  ModuleAndList m_and;

public:

  TopModule(sc_module_name mn):
    a("ModuleA"),
    m("Module"),
    m_or("ModuleOrList"),
    m_and("ModuleAndList")
  { }
};

int sc_main(int argc, char **argv)
{
  TopModule m("top");
  sc_start();
  return 0;
}
