#include "systemc.h"

#define RISC_ALL_SEGMENT_TESTS 1

#include "input_straight.cpp"
#include "input_if_else.cpp"
#include "input_for.cpp"
#include "input_for_break.cpp"
#include "input_for_continue.cpp"
#include "input_while.cpp"
#include "input_while_break.cpp"
#include "input_while_continue.cpp"
#include "input_do_while.cpp"
#include "input_do_while_break.cpp"
#include "input_do_while_continue.cpp"
#include "input_while_if_else.cpp"
#include "input_nested_test.cpp"
#include "input_switch.cpp"
#include "input_misc.cpp"
#include "input_sequential_statements_with_wait.cpp"

SC_MODULE(M)
{
  ForBreak m1;
  WhileBreak m2;
  DoWhileBreak m3;

  ForContinue m4;
  WhileContinue m5;
  DoWhileContinue m6;

  For m7;
  While m8;
  DoWhile m9;

  Switch m10;
  Misc m11;
  Straight m12;
  IfElse m13;
  Nested m14;
  SequentialStatements m15;

  WhileIfElse m16;

  SC_CTOR(M):
    m1("m1"),
    m2("m2"),
    m3("m3"),

    m4("m4"),
    m5("m5"),
    m6("m6"),

    m7("m7"),
    m8("m8"),
    m9("m9"),

    m10("m10"),
    m11("m11"),
    m12("m12"),
    m13("m13"),
    m14("m14"),
    m15("m15"),
    m16("m16")
  { }
};

int sc_main(int argc, char **argv)
{
  M m("m");
  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
