.TH visual l "March 6, 2018"
.SH NAME
.B visual
\- Graphical SystemC Module Visualizer using RISC
.SH SYNOPSIS
.B visual
[
.I options
]
.I design
[
.I options
]
.SH DESCRIPTION
.B visual
is an analysis tool for graphical visualizing of ports and modules of SystemC code. It uses the RISC compiler to parse and analyze the SystemC source code into a data structure. The tool iterates through this data structure and displays a visual representation of the hierarchy of modules and ports. 
.B visual
provides a GUI to provide a graphical representation of the SystemC model as well as provide user modifiable options during run-time to change the graphical properties of the visualization.
.SH ARGUMENTS
.TP
.I design
specifies the file name of the input SystemC model.
.SH OPTIONS
.I \-h | \-\-help
prints a brief message on the usage of the tool to standard output and quits;
.TP
.I \-bw
Modules are drawing without color;
.TP
.I \-tm module
Only draw "module";
.TP
.I \-Il integer
Draw only a certain depth in the hierarchy given by "integer";
.TP
.I \-s float
Scale the drawing size by "float". If "float" = 0.5, then the size of the drawing is scaled by 50 percent.
.TP
.I \-np
The module hierachy will be drawn without ports or channels;
.SH ENVIRONMENT
.TP
.I RISC
is used to compile-time to determine the installation directory of the RISC compiler and simulator where the RISC system components are located.
.TP
.I SYSTEMC_LW_HOME
is used at run-time to find the RISC light-weight SystemC header files which are expected in directory $SYSTEMC_LW_HOME/include
.SH VERSION
Visual is release version 0.4.2
.SH AUTHORS
Daniel Mendoza <dmmendo1@uci.edu>
.SH COPYRIGHT
(c) 2018 CECS, University of California, Irvine
.SH LICENSE
Open source BSD license terms apply.
.SH BUGS, LIMITATIONS
This is an academic proof-of-concept prototype implementation,
not commercial-quality software. GTK is used at compile-time for the GUI. CAIRO
is used at compile-time for drawings displayed on the GUI.

